#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.1.13
Release:	1%{dist}
Summary:	The Qubes GUI virtualization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg
Requires:	service(graphical-login)
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   python%{python3_pkgversion}-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   qubes-core-qrexec >= 4.1.5
Requires:   python%{python3_pkgversion}-qubesimgconverter >= 4.1.4
Requires:   socat

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:	libXt-devel
BuildRequires:	libXext-devel
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	qubes-db-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in GuiVM.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
# Pull also audio packages for easier upgrade
Requires:   qubes-audio-daemon
Requires:   qubes-audio-dom0
Requires:	qubes-core-dom0 >= 4.1.1
# for policy.EvalSimple service
Requires:	qubes-core-qrexec-dom0 >= 4.1.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%package -n qubes-audio-daemon
Summary:	The Qubes AUDIO virtualization
Requires:	pulseaudio-libs
Requires:	pulseaudio
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

%description -n qubes-audio-daemon
The Qubes AUDIO virtualization infrastructure that needs to be installed in AudioVM.

%package -n qubes-audio-dom0
Summary:    Dom0 part of Qubes AUDIO
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-audio-dom0
Dom0 files for Qubes AUDIO virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/xdg/autostart/qubes-icon-receiver.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes/rpc-config/qubes.WindowIconUpdater

%files -n qubes-audio-daemon
/usr/bin/pacat-simple-vchan
/etc/qubes-rpc/qubes.AudioInputEnable
/etc/qubes-rpc/qubes.AudioInputDisable

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.ClipboardPaste
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.WindowIconUpdater

%files -n qubes-audio-dom0
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Fri Jun 18 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon.git

* Fri Jun 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a229a77
- version 4.1.13

* Fri Jun 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a45f92e
- rpm: require qrexec new enough for policy.EvalSimple service

* Wed Jun 02 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f8b837b
- Miscellaneous cleanups

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - cac9446
- Move XInternAtom calls to startup

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4002e16
- Avoid dangerous functions in shmoverride

* Sat May 29 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b770e02
- Support clipboard outside of dom0

* Wed May 12 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8ad59e4
- Remove @asyncio.coroutine

* Tue May 04 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 029e49f
- Remove deprecated qrexec policy syntax

* Sat Apr 24 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 1691800
- Rip out @asyncio.coroutine

* Wed Jan 06 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 937fd8a
- version 4.1.12

* Fri Dec 11 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c738b04
- Fix clipboard stop working after ~50 days of uptime

* Thu Dec 10 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - fe8e013
- Enforce locale for help2man

* Sun Dec 06 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 69129f6
- Never pass an invalid X11 operation to dom0

* Sun Dec 06 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - ed88078
- Check syscall return values

* Sun Dec 06 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - ed2c43a
- Replace /var/run with /run

* Sun Dec 06 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 020c707
- Miscellaneous hardening

* Sat Dec 05 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 6bc29b0
- Don’t crash if there is no window manager

* Sat Dec 05 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - f19ad95
- Use desktop_coordinates_size instead of a magic number

* Fri Dec 04 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 4d301dd
- Remove hard-coded magic numbers

* Fri Dec 04 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 3ddbb38
- Respond to code review from @marmarek

* Thu Dec 03 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - e0f969f
- Listen for property changes instead of polling

* Wed Dec 02 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 3d7afe1
- Use the work area instead of root window size

* Wed Dec 02 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - cd6f308
- Use --override-redirect=disabled

* Tue Dec 01 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 09c9470
- Make the build detect BACKEND_VMM based on installed vchan version

* Tue Dec 01 2020 Demi Marie Obenour <athena@invisiblethingslab.com> - 2a1d4c0
- More protection vs override redirect windows

* Wed Nov 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cd4f205
- gitlab-ci: adjust install excludes

* Sun Nov 15 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - a6e606b
- Add .gitlab-ci.yml

* Fri Nov 13 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d24ff53
- version 4.1.11

* Thu Nov 12 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c66d079
- xside: don't hang indefinitely if VM is killed early

* Tue Oct 27 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6e1a694
- Fix handling X11 exit

* Fri Sep 18 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d076904
- version 4.1.10

* Tue Sep 01 2020 John Hensley <john@freedom.press> - 58772f4
- icon-receiver: exit on X connection error

* Mon Aug 31 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b314cbf
- version 4.1.9

* Fri Aug 07 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - c1480c3
- Update travis

* Thu Jul 30 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8352e14
- version 4.1.8

* Tue Jul 28 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 2de2bd8
- Handle destroyed windows in restack_windows

* Mon Jul 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - ad75e04
- Make screensaver detection configurable

* Thu Jul 23 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 2607198
- Prevent VM notifications from appearing on top of xscreensaver

* Wed Jul 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e1144d1
- version 4.1.7

* Mon Jun 29 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 3c3454d
- Add a warning to the configuration file

* Mon Jun 29 2020 Dmitry Fedorov <d.fedorov@tabit.pro> - 7287726
- audio: quit if io_new() fails

* Sun Jun 28 2020 Dmitry Fedorov <d.fedorov@tabit.pro> - 50845df
- audio: fix indentation

* Sun Jun 28 2020 Dmitry Fedorov <d.fedorov@tabit.pro> - a2aa623
- audio: register vchan' callbacks when stream in PA_STREAM_READY state

* Thu Jun 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 1944a9e
- Remove audio_low_latency option (not used anymore)

* Thu Jun 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - eb5c544
- Allow overriding configuration file

* Sat Jun 20 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e2efb9b
- Update dependencies for icon receiver

* Fri Jun 19 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 37dfee0
- shmoverride: fill shm_perm when faking shmctl(IPC_STAT) output

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - abbf084
- version 4.1.6

* Thu Apr 30 2020 Ivan Kardykov <kardykov@tabit.pro> - d482e69
- set override redirect attribute on window creating

* Fri Apr 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3ed85ac
- version 4.1.5

